Bug 144757 - In Options - LibreOffice - Fonts - Font Settings for HTML, Basic and SQL Sources - font list not-displayed in dropdown menu unless tickbox "Non-proportional fonts only" is unticked.
Summary: In Options - LibreOffice - Fonts - Font Settings for HTML, Basic and SQL Sour...
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: graphics stack (show other bugs)
Version:
(earliest affected)
7.1.6.2 release
Hardware: x86-64 (AMD64) macOS (All)
: medium normal
Assignee: Chris Sherlock
URL:
Whiteboard: target:7.3.0 target:7.2.3
Keywords:
: 144762 (view as bug list)
Depends on:
Blocks: Fonts-Name-Combobox
  Show dependency treegraph
 
Reported: 2021-09-28 08:28 UTC by Alexander Van den Panhuysen
Modified: 2021-10-12 19:37 UTC (History)
2 users (show)

See Also:
Crash report or crash signature:
Regression By:


Attachments
A Font listing is missing. (218.87 KB, image/png)
2021-09-28 08:37 UTC, Alexander Van den Panhuysen
Details
Screenshot of Inactive Font Change (189.28 KB, image/png)
2021-09-30 07:44 UTC, Alex Thurgood
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Alexander Van den Panhuysen 2021-09-28 08:28:38 UTC
Description:
I am using the latest stable version 7.1.6.2 om my MacBook Air, but I'm unable to change the font for the Basic Editor. Is something badly installed or missing on my computer or is it a bug in that version? It was also not working in previous versions sorry.

Steps to Reproduce:
1.Open Options
2.Select Fonts in LibreOffice
3.Try to change Fonts in Font Setting for HTML, Basic and SQL Sources.

Actual Results:
When I click then on the vertical scroll-item, I stil have only Automatic and nothing else.

Expected Results:
I expect a long list of installed fonts so I can select an other font.


Reproducible: Always


User Profile Reset: No



Additional Info:
[Information automatically included from LibreOffice]
Locale: en-US
Module: BasicIDE
[Information guessed from browser]
OS: Mac OS X (All)
OS is 64bit: no
Comment 1 Alexander Van den Panhuysen 2021-09-28 08:37:05 UTC
Created attachment 175305 [details]
A Font listing is missing.
Comment 2 Mike Kaganski 2021-09-28 11:38:19 UTC
*** Bug 144762 has been marked as a duplicate of this bug. ***
Comment 3 Julien Nabet 2021-09-28 18:56:27 UTC
Just for the record, I don't reproduce this on pc Debian x86-64 with master sources updated today (with gtk3 or gen rendering).
Perhaps MacOs only bug?
Comment 4 Alexander Van den Panhuysen 2021-09-29 05:48:20 UTC Comment hidden (off-topic)
Comment 5 Mike Kaganski 2021-09-29 06:10:50 UTC Comment hidden (off-topic)
Comment 6 Alexander Van den Panhuysen 2021-09-29 06:54:52 UTC Comment hidden (off-topic)
Comment 7 Mike Kaganski 2021-09-29 07:43:51 UTC Comment hidden (off-topic)
Comment 8 Alex Thurgood 2021-09-29 08:48:26 UTC
I seem to recall from previous discussion elsewhere that this can't actually be changed and has never worked, probably inherited from OOo.
Comment 9 Alex Thurgood 2021-09-29 10:40:49 UTC
Confirming with

Version: 7.1.6.2 / LibreOffice Community
Build ID: 0e133318fcee89abacd6a7d077e292f1145735c3
CPU threads: 8; OS: Mac OS X 10.16; UI render: default; VCL: osx
Locale: fr-FR (fr_FR.UTF-8); UI: fr-FR
Calc: threaded
Comment 10 Alex Thurgood 2021-09-29 10:49:32 UTC

*** This bug has been marked as a duplicate of bug 117793 ***
Comment 11 Alex Thurgood 2021-09-29 10:53:14 UTC
@Alexander : if you untick the Proportional Fonts option, you will get a list of available fonts in the dropdown menu above.

However, even if you  select a font from this list and restart LO, the font chosen doesn't appear to be used in the Basic IDE that I can see.

I tried setting the dropdown value to Apple Emoji font, applied the setting, shutdown LO, restarted it, and loaded a Base document. Neither in the Query SQL designer, nor in the Basic IDE was the font changed.
Comment 12 Mike Kaganski 2021-09-29 18:34:23 UTC
(In reply to Alex Thurgood from comment #10)
> 
> *** This bug has been marked as a duplicate of bug 117793 ***

Alex, I fail to see how could this be a duplicate of that bug, which is not specific to macOS (is reported on Windows), not related to Basic, and is about missing functionality in Base?

Basic IDE definitely follows the "Font Setting for HTML, Basic and SQL Sources" setting (which shows non-proportional fonts fine) on e.g. Version: 7.2.2.1 (x64) / LibreOffice Community
Build ID: 0e408af0b27894d652a87aa5f21fe17bf058124c
CPU threads: 12; OS: Windows 10.0 Build 19043; UI render: default; VCL: win
Locale: ru-RU (ru_RU); UI: en-US
Calc: threaded.
Comment 13 Alex Thurgood 2021-09-30 07:34:50 UTC
@Mike : fine by me.
Comment 14 Alex Thurgood 2021-09-30 07:43:16 UTC
Also reproducible with

Version: 7.3.0.0.alpha0+ / LibreOffice Community
Build ID: bc7baa18435000f47f90e47d3300710bcb4cf56b
CPU threads: 8; OS: Mac OS X 10.16; UI render: default; VCL: osx
Locale: fr-FR (fr_FR.UTF-8); UI: en-US
Calc: threaded

cf. screenshot when using the Basic IDE, but the result is the same for the SQL query window.
Comment 15 Alex Thurgood 2021-09-30 07:44:04 UTC
Created attachment 175387 [details]
Screenshot of Inactive Font Change
Comment 16 Mike Kaganski 2021-09-30 07:54:48 UTC
(In reply to Alex Thurgood from comment #15)

So the screenshot shows that the font gets applied and used fine when "non-proportional fonts only" is unchecked (as you described in comment 11); and the issue is exactly the failure to find/populate non-proportional fonts to the box on macOS, right?

Tor, you are the macOS expert, maybe you see something obvious here?
Comment 17 Alex Thurgood 2021-09-30 09:37:58 UTC
(In reply to Mike Kaganski from comment #16)
> (In reply to Alex Thurgood from comment #15)
> 
> So the screenshot shows that the font gets applied and used fine when
> "non-proportional fonts only" is unchecked (as you described in comment 11);
> and the issue is exactly the failure to find/populate non-proportional fonts
> to the box on macOS, right?

Indeed.
Comment 18 Chris Sherlock 2021-10-09 14:08:34 UTC
Non-proportional fonts picked from this list on MacOS change the font fine for me, and I don't need to restart LibreOffice. The problem reported in this patch is still occurring. 

Can I get some code pointers on what populates the dropdown box?
Comment 19 Chris Sherlock 2021-10-09 14:50:20 UTC
Seems to be a problem in FontList, part of svtools.
Comment 20 Chris Sherlock 2021-10-09 16:01:08 UTC
So the issue is actually in the way that we get the fonts from MacOS. All fonts on MacOS are returning as variable fonts. Obviously, nothing will populate in that box without a fixed width font. 

The bug is that fixed width fonts like courier don't have a fixed pitch.
Comment 21 Chris Sherlock 2021-10-09 16:50:37 UTC
Could someone please test out a patch I have just pushed to gerrit?

https://gerrit.libreoffice.org/c/core/+/123316
Comment 22 Commit Notification 2021-10-10 05:50:04 UTC
Chris Sherlock committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/d389a54e64accc3f46c1a646f947e9af9badd08e

tdf#144757 - fixed fonts not shown in font list

It will be available in 7.3.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 23 Alex Thurgood 2021-10-11 08:53:36 UTC
Seems to be fixed with that commit Chris, thanks !

Tested in Version: 7.3.0.0.alpha0+ / LibreOffice Community
Build ID: 56883788d0090383dad58552f5a11044ffe64a44
CPU threads: 8; OS: Mac OS X 10.16; UI render: default; VCL: osx
Locale: fr-FR (fr_FR.UTF-8); UI: en-US
Calc: threaded
Comment 24 Commit Notification 2021-10-12 19:37:12 UTC
Chris Sherlock committed a patch related to this issue.
It has been pushed to "libreoffice-7-2":

https://git.libreoffice.org/core/commit/8da2af99cc205d7c79cd119ccb32a5f3de4ea204

tdf#144757 - fixed fonts not shown in font list

It will be available in 7.2.3.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.